program Sorter
begin
   { gets the input list from user }
   ok,list:=InputQuery( 
      'Sorter - input list',
      'Type a list of words, separated by comma',
      '' );

   if ok then
   begin
      { list sorting using selection method }
      for c:=WordCount(list) to 2 step -1 do
      begin
         i:=c;
         for c1:=c-1 to 1 step -1 do
            if Trim(GetWord(list,c1))>Trim(GetWord(list,i)) then i:=c1;
         { swap words "i" and "c" }
         aux:=GetWord(list,i);
         list:=InsertWord(RemoveWord(list,i),i,Trim(GetWord(list,c)));
         list:=InsertWord(RemoveWord(list,c),c,Trim(aux));
      end;
      { show the sorted list }
      ShowMessage( 'The sorted list is: '+list );
   end;
end;

routine WordCount
begin
   get list;

   { count the words in input list, separated by comma }
   result:=1;
   for c:=1 to length(list) do
      if copy(list,c,1)=',' then result:=result+1;

   return result;
end;

routine GetWord
begin
   get list,index;

   { extracts then word pointed by index }
   i:=1;
   p:=1;
   word:='';
   for c:=0 to length(list) do
   begin
      if (c=length(list)) or (copy(list,c+1,1)=',') then 
      begin
         if index=i then
         begin
            word:=copy( list,p,c-p+1 );
            break;
         end;
         i:=i+1;
         p:=c+2;
      end;
   end;
   return word;
end;

routine WordStart
begin
   get list,index;
   
   { returns the start position of word pointed by index }
   i:=1;
   p:=1;
   for c:=0 to length(list) do
   begin
      if (c=length(list)) or (copy(list,c+1,1)=',') then 
      begin
         if index=i then
         begin
            return p;
            break;
         end;
         i:=i+1;
         p:=c+2;
      end;
   end;
end;

routine RemoveWord
begin
   get list,index;
   
   { deletes the word pointed by index }
   return delete( list, WordStart(list,index), length(GetWord(list,index)) );
end;

routine InsertWord
begin
   get list, index, word;
  
   { inserts the word into list, pointed by index }
   return insert( word, list, WordStart(list,index) );
end;